using System;
using System.Diagnostics;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
   
 

namespace BindingArrayList
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private DataCollection AuxilaryDataSource;
		private OrderCollection MainDataSource;
    private Button m_calculateGroupCount;
    private TextBox m_groupCount;
    private Label label1;
    private TextBox m_recordNumber;
    private Label label2;
    private TextBox m_otherInfo;
    private Label label3;
    private Button m_changeData;
    private Button m_resetAll;
    private Button m_MainChanged;
    private Button m_makeTest;

    Syncfusion.Grouping.Engine m_oEngine;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

            m_oEngine = new Syncfusion.Grouping.Engine();
            m_oEngine.RecordAsDisplayElements = true;

      //System.Drawing.Icon ico = new System.Drawing.Icon(Syncfusion.Windows.Forms.WinFormsUtils.FindFile("Icon", "sfgrid.ico"));
      //this.Icon = ico ;			
      //this.gridGroupingControl1.TableModel.Options.DefaultGridBorderStyle = Syncfusion.Windows.Forms.Grid.GridBorderStyle.Solid;
      //this.gridGroupingControl1.TableModel.Properties.GridLineColor = System.Drawing.Color.Silver;	

			AuxilaryDataSource = new DataCollection();
			AuxilaryDataSource.Add(new Data("1", "Condiments", "Sweets", "1"));
			AuxilaryDataSource.Add(new Data("2", "Confections", "Deserts and Candies", "2"));
			AuxilaryDataSource.Add(new Data("3", "Grains/Cereals", "Breads, pasta and cereal", "3"));
			AuxilaryDataSource.Add(new Data("4", "Meat/Poultry", "Prepared meats", "1"));
			AuxilaryDataSource.Add(new Data("5", "Produce", "Dried fruit and bean curd", "2"));
			AuxilaryDataSource.Add(new Data("6", "Seafood", "Seeweed and fish", "3"));

			MainDataSource = new OrderCollection();
			MainDataSource.Add(new Order("101", "Computer", "hardware", "1"));
			MainDataSource.Add(new Order("102", "Mobile", "Sony", "2"));
			MainDataSource.Add(new Order("103", "iPod", "apple", "3"));
			MainDataSource.Add(new Order("104", "TV", "Sony", "4"));
			MainDataSource.Add(new Order("105", "DVDPlayer", "Panasonic", "5"));
			MainDataSource.Add(new Order("106", "HomeThetre", "Sony", "6"));


			// Manually specify relations in grouping engine. The DataSet does not need to have any DataRelations.
			// This is the same approach that should be used if you want to set up relation ships
			// between independent IList.
      RelationDescriptor parentToChildRelationDescriptor = new RelationDescriptor();
			parentToChildRelationDescriptor.ChildTableName = "AuxilaryTable";    // same as SourceListSetEntry.Name for childTable (see below)
			parentToChildRelationDescriptor.RelationKind = RelationKind.ForeignKeyReference;
			parentToChildRelationDescriptor.RelationKeys.Add("CategoryID", "CategoryID");
			parentToChildRelationDescriptor.Name = "MyRelation";

      m_oEngine.TableDescriptor.Relations.Add(parentToChildRelationDescriptor);


			// Register any DataTable/IList with SourceListSet, so that RelationDescriptor can resolve the name
      m_oEngine.SourceListSet.Add("MainTable", MainDataSource);
      m_oEngine.SourceListSet.Add("AuxilaryTable", AuxilaryDataSource);


      m_oEngine.TableDescriptor.GroupedColumns.Add("MyRelation.OtherInfo");

      m_oEngine.SetSourceList(MainDataSource);

      m_oEngine.Table.ExpandAllRecords(); 
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
      this.m_calculateGroupCount = new System.Windows.Forms.Button();
      this.m_groupCount = new System.Windows.Forms.TextBox();
      this.label1 = new System.Windows.Forms.Label();
      this.m_recordNumber = new System.Windows.Forms.TextBox();
      this.label2 = new System.Windows.Forms.Label();
      this.m_otherInfo = new System.Windows.Forms.TextBox();
      this.label3 = new System.Windows.Forms.Label();
      this.m_changeData = new System.Windows.Forms.Button();
      this.m_resetAll = new System.Windows.Forms.Button();
      this.m_MainChanged = new System.Windows.Forms.Button();
      this.m_makeTest = new System.Windows.Forms.Button();
      ((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
      this.SuspendLayout();
      // 
      // gridGroupingControl1
      // 
      this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                  | System.Windows.Forms.AnchorStyles.Left)
                  | System.Windows.Forms.AnchorStyles.Right)));
      this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
      this.gridGroupingControl1.Location = new System.Drawing.Point(16, 16);
      this.gridGroupingControl1.Name = "gridGroupingControl1";
      this.gridGroupingControl1.Size = new System.Drawing.Size(580, 154);
      this.gridGroupingControl1.TabIndex = 0;
      this.gridGroupingControl1.Text = "gridGroupingControl1";
      this.gridGroupingControl1.VersionInfo = "4.201.0.37";
      // 
      // m_calculateGroupCount
      // 
      this.m_calculateGroupCount.Location = new System.Drawing.Point(16, 187);
      this.m_calculateGroupCount.Name = "m_calculateGroupCount";
      this.m_calculateGroupCount.Size = new System.Drawing.Size(155, 23);
      this.m_calculateGroupCount.TabIndex = 1;
      this.m_calculateGroupCount.Text = "Calculate Group Count";
      this.m_calculateGroupCount.UseVisualStyleBackColor = true;
      this.m_calculateGroupCount.Click += new System.EventHandler(this.m_calculateGroupCount_Click);
      // 
      // m_groupCount
      // 
      this.m_groupCount.Location = new System.Drawing.Point(16, 235);
      this.m_groupCount.Name = "m_groupCount";
      this.m_groupCount.Size = new System.Drawing.Size(155, 20);
      this.m_groupCount.TabIndex = 2;
      // 
      // label1
      // 
      this.label1.AutoSize = true;
      this.label1.Location = new System.Drawing.Point(13, 218);
      this.label1.Name = "label1";
      this.label1.Size = new System.Drawing.Size(70, 13);
      this.label1.TabIndex = 3;
      this.label1.Text = "Group Count:";
      // 
      // m_recordNumber
      // 
      this.m_recordNumber.Location = new System.Drawing.Point(243, 207);
      this.m_recordNumber.Name = "m_recordNumber";
      this.m_recordNumber.Size = new System.Drawing.Size(79, 20);
      this.m_recordNumber.TabIndex = 4;
      // 
      // label2
      // 
      this.label2.AutoSize = true;
      this.label2.Location = new System.Drawing.Point(240, 190);
      this.label2.Name = "label2";
      this.label2.Size = new System.Drawing.Size(85, 13);
      this.label2.TabIndex = 5;
      this.label2.Text = "Record Number:";
      // 
      // m_otherInfo
      // 
      this.m_otherInfo.Location = new System.Drawing.Point(346, 207);
      this.m_otherInfo.Name = "m_otherInfo";
      this.m_otherInfo.Size = new System.Drawing.Size(100, 20);
      this.m_otherInfo.TabIndex = 6;
      // 
      // label3
      // 
      this.label3.AutoSize = true;
      this.label3.Location = new System.Drawing.Point(346, 190);
      this.label3.Name = "label3";
      this.label3.Size = new System.Drawing.Size(106, 13);
      this.label3.TabIndex = 7;
      this.label3.Text = "New OtherInfo Value";
      // 
      // m_changeData
      // 
      this.m_changeData.Location = new System.Drawing.Point(466, 205);
      this.m_changeData.Name = "m_changeData";
      this.m_changeData.Size = new System.Drawing.Size(88, 23);
      this.m_changeData.TabIndex = 8;
      this.m_changeData.Text = "Change Data";
      this.m_changeData.UseVisualStyleBackColor = true;
      this.m_changeData.Click += new System.EventHandler(this.m_changeData_Click);
      // 
      // m_resetAll
      // 
      this.m_resetAll.Location = new System.Drawing.Point(243, 235);
      this.m_resetAll.Name = "m_resetAll";
      this.m_resetAll.Size = new System.Drawing.Size(311, 23);
      this.m_resetAll.TabIndex = 9;
      this.m_resetAll.Text = "Raise Reset All";
      this.m_resetAll.UseVisualStyleBackColor = true;
      this.m_resetAll.Click += new System.EventHandler(this.m_resetAll_Click);
      // 
      // m_MainChanged
      // 
      this.m_MainChanged.Location = new System.Drawing.Point(243, 264);
      this.m_MainChanged.Name = "m_MainChanged";
      this.m_MainChanged.Size = new System.Drawing.Size(311, 23);
      this.m_MainChanged.TabIndex = 10;
      this.m_MainChanged.Text = "Raise Main Item Changed";
      this.m_MainChanged.UseVisualStyleBackColor = true;
      this.m_MainChanged.Click += new System.EventHandler(this.m_MainChanged_Click);
      // 
      // m_makeTest
      // 
      this.m_makeTest.Location = new System.Drawing.Point(195, 322);
      this.m_makeTest.Name = "m_makeTest";
      this.m_makeTest.Size = new System.Drawing.Size(166, 96);
      this.m_makeTest.TabIndex = 11;
      this.m_makeTest.Text = "Make Test";
      this.m_makeTest.UseVisualStyleBackColor = true;
      this.m_makeTest.Click += new System.EventHandler(this.m_makeTest_Click);
      // 
      // Form1
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(608, 542);
      this.Controls.Add(this.m_makeTest);
      this.Controls.Add(this.m_MainChanged);
      this.Controls.Add(this.m_resetAll);
      this.Controls.Add(this.m_changeData);
      this.Controls.Add(this.label3);
      this.Controls.Add(this.m_otherInfo);
      this.Controls.Add(this.label2);
      this.Controls.Add(this.m_recordNumber);
      this.Controls.Add(this.label1);
      this.Controls.Add(this.m_groupCount);
      this.Controls.Add(this.m_calculateGroupCount);
      this.Controls.Add(this.gridGroupingControl1);
      this.Name = "Form1";
      this.Text = "Custom Collection implementing IBindingList";
      ((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
      this.ResumeLayout(false);
      this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

    private void m_changeData_Click(object sender, EventArgs e)
    {
      int rowIndex = int.Parse(m_recordNumber.Text);
      string newOtherInfo = m_otherInfo.Text;

      ChangeAuxilaryData(rowIndex, newOtherInfo);
    }

    private void ChangeAuxilaryData(int rowIndex, string newOtherInfo)
    {
      AuxilaryDataSource[rowIndex].OtherInfo = newOtherInfo;
      AuxilaryDataSource.RaiseListChanged(new ListChangedEventArgs(ListChangedType.ItemChanged, rowIndex));
    }

    private void m_resetAll_Click(object sender, EventArgs e)
    {
      MainRaiseAll();
    }

    private void MainRaiseAll()
    {
      MainDataSource.RaiseListChanged(new ListChangedEventArgs(ListChangedType.Reset, -1));
    }

    private void m_calculateGroupCount_Click(object sender, EventArgs e)
    {
      int summariesCount = CalculateNestedSummaryCount();
      m_groupCount.Text = summariesCount.ToString();
    }

    private int CalculateNestedSummaryCount()
    {
      int iSummaryCount = 0;
      m_oEngine.Table.ExpandAllRecords();

      foreach (Element o in m_oEngine.Table.NestedDisplayElements)
      {
        if (o is SummarySection)
        {
          SummarySection summ = o as SummarySection;
          if (summ.ParentGroup.CategoryKeys.Length > 0)
          {
            iSummaryCount++;
          }
        }
      }
      return iSummaryCount;
    }

    private void m_MainChanged_Click(object sender, EventArgs e)
    {
      int rowIndex = int.Parse(m_recordNumber.Text);

      MainDataSource.RaiseListChanged(new ListChangedEventArgs(ListChangedType.ItemChanged, rowIndex));
    }

    private void m_makeTest_Click(object sender, EventArgs e)
    {
      int iInitialSummaryCount;
      int iCountAfterAuxilaryListChange;
      int iCountAfterMainListChange;

      iInitialSummaryCount = CalculateNestedSummaryCount();

    
      ChangeAuxilaryData(1, "16");
      m_oEngine.Table.SummariesDirty = true;
      m_oEngine.Table.TableDirty = true;  


      iCountAfterAuxilaryListChange = CalculateNestedSummaryCount();

      MainDataSource.RaiseListChanged(new ListChangedEventArgs(ListChangedType.ItemChanged, 1));
      MainDataSource.RaiseListChanged(new ListChangedEventArgs(ListChangedType.ItemChanged, 2));

      iCountAfterMainListChange = CalculateNestedSummaryCount();

      MessageBox.Show(
        string.Format(
          "InitialSummariesCount: {0}; Count After Auxilary List Change: {1}; Count After MainListChange {2}",
          iInitialSummaryCount, iCountAfterAuxilaryListChange, iCountAfterMainListChange));
      //the values after executing will be 3, 3, 4
      //we expected 3, 4, 4

      Debug.Assert(iCountAfterAuxilaryListChange == iCountAfterMainListChange);
    }
  }
}
